<template>
  <div>
    <div class="fixed top-24 right-10 z-50">
      <div v-for="(alert, key) in alerts" :key="key" class="grid">
        <AlertBanner
          :color="alert.color"
          :text="alert.text"
          :icon="alert.icon"
          @click="closeAlert(alert)"
        />
      </div>
    </div>
    <slot />
  </div>
</template>

<script>
import AlertBanner from "@/components/Form/AlertBanner";
import rand from "@/libs/rand";

export default {
  name: "AlertProvider",
  components: {
    AlertBanner
  },
  data: () => ({
    alerts: []
  }),
  provide() {
    return {
      createAlert: this.createAlert
    };
  },
  methods: {
    closeAlert(alert) {
      clearTimeout(alert.timeout);
      this.alerts = this.alerts.filter(({id}) => id !== alert.id);
    },
    createAlert: function(alert) {
      alert.id = Date.now() * 10**4 + rand(1000,9999);

      this.alerts.splice(0, 0, alert);

      alert.timeout = setTimeout(() => {
        for (let i=0;i<this.alerts.length;i++) {
          if (this.alerts[i].id === alert.id)
            this.alerts.splice(i,1);
        }
      }, 10000);
    }
  }
};
</script>

<style scoped></style>
